/**
***     TimerApp.c
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"
#include "AEEShell.h"
#include "TimerApp.bid"
#include "AEEGraphics.h"
#include "AEETime.h"
#include "AEEDate.h"

#define     TIMER_INTERVAL      (300)
#define     TIMECTL_HEIGHT      (20)

// Avbg\
typedef struct TimerApp {
    AEEApplet a; // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱

    // ʕ`p
    int width;
    int height;
    int font_height;

    ITimeCtl* timectl; // ITimeCtl C^[tF[X̃CX^Xϐ
} TimerApp;

static boolean TimerApp_HandleEvent(TimerApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static void Draw(TimerApp* app);
static boolean OnAppStart(TimerApp* app);
static boolean OnAppStop(TimerApp* app);
static boolean OnKey(TimerApp* app, uint16 key);
static void OnTimerExpired(TimerApp* app);
static void MakeTimeCtl(TimerApp* app);

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;
    if (ClsId == AEECLSID_TIMERAPP) {
        if (AEEApplet_New(sizeof(TimerApp), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)TimerApp_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

static boolean TimerApp_HandleEvent(TimerApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    switch (eCode) {
        case EVT_APP_START:
            return OnAppStart(app);

        case EVT_APP_STOP:
            return OnAppStop(app);

        case EVT_KEY:
            return OnKey(app, wParam);
    }
    return FALSE;
}

// ʕ`
static void Draw(TimerApp* app)
{
    IDISPLAY_ClearScreen(app->a.m_pIDisplay);
    if (app->timectl != NULL) {
        // ̍Đݒ:
        // TIMER_INTERVAL ̊ԊuŌݎǂݎ ITIMECTL ̃CX^XɍĐݒ肵āA
        // AEECLSID_COUNTDOWNCTL `ŕ\
        ITIMECTL_SetTime(app->timectl, GETTIMEMS());
        // ĕ`
        ITIMECTL_Redraw(app->timectl);
    }
    else {
        IDisplay* d = app->a.m_pIDisplay;
        AEERect rect;
        JulianType julian;
        char string[32];
        char week[][5] = {"", "", "", "", "", "y", ""};
        AECHAR wstring[32];

        rect.x = 10;
        rect.dx = app->width - 20;
        rect.dy = TIMECTL_HEIGHT;
        // JulianType Ɍݎ̏擾
        GETJULIANDATE(GETTIMESECONDS(), &julian);

        rect.y = 10;
        // N𕶎\
        SPRINTF(string, "%4d/%2d/%2d", julian.wYear, julian.wMonth, julian.wDay);
        STRTOWSTR(string, wstring, sizeof(wstring) * sizeof(AECHAR));
        IDISPLAY_DrawText(d, AEE_FONT_NORMAL, wstring, -1, 0, TIMECTL_HEIGHT, &rect, IDF_ALIGN_RIGHT | IDF_ALIGN_TOP);

        rect.y = 10 + TIMECTL_HEIGHT;
        // b𕶎\
        SPRINTF(string, "%2d:%02d:%02d", julian.wHour, julian.wMinute, julian.wSecond);
        STRTOWSTR(string, wstring, sizeof(wstring) * sizeof(AECHAR));
        IDISPLAY_DrawText(d, AEE_FONT_NORMAL, wstring, -1, 0, TIMECTL_HEIGHT, &rect, IDF_ALIGN_RIGHT | IDF_ALIGN_TOP);

        rect.y = 10 + TIMECTL_HEIGHT * 2;
        // j𕶎\
        SPRINTF(string, "%sj", week[julian.wWeekDay]);
        STRTOWSTR(string, wstring, sizeof(wstring) * sizeof(AECHAR));
        IDISPLAY_DrawText(d, AEE_FONT_NORMAL, wstring, -1, 0, TIMECTL_HEIGHT, &rect, IDF_ALIGN_RIGHT | IDF_ALIGN_TOP);

        IDISPLAY_Update(d);
    }
    return;
}

// AvbgJnƂɌĂяoB
static boolean OnAppStart(TimerApp* app)
{
    AEEDeviceInfo devinfo;
    IShell* shell = app->a.m_pIShell;

    // IShellC^[tFCX֐gpāAʃTCY擾B
    ISHELL_GetDeviceInfo(shell, &devinfo);
    app->width = devinfo.cxScreen;
    app->height = devinfo.cyScreen;

    MakeTimeCtl(app);
    OnTimerExpired(app);
    return TRUE;
}

// AvbgIƂɌĂяoB
static boolean OnAppStop(TimerApp* app)
{
    // e
    if (app->timectl != NULL) {
        ITIMECTL_Release(app->timectl);
    }
    ISHELL_CancelTimer(app->a.m_pIShell, (PFNNOTIFY)OnTimerExpired, app);
    return TRUE;
}

// L[ꂽƂɌĂяoB
static boolean OnKey(TimerApp* app, uint16 key)
{
    switch (key) {
        case AVK_SELECT:
            if (app->timectl == NULL) {
                MakeTimeCtl(app);
            }
            else {
                ITIMECTL_Release(app->timectl);
                app->timectl = NULL;
            }
            Draw(app);
            return TRUE;
    }
    return FALSE;
}

// ^C}[̃R[obN֐
static void OnTimerExpired(TimerApp* app)
{
    // ^C}[̍Đݒ
    ISHELL_SetTimer(app->a.m_pIShell, TIMER_INTERVAL, (PFNNOTIFY)OnTimerExpired, app);
    // ʕ`
    Draw(app);
    return;
}

// ITimeCtl ̐
static void MakeTimeCtl(TimerApp* app)
{
    IShell* shell = app->a.m_pIShell;
    AEERect rect;

    // CX^X̐
    app->timectl = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_COUNTDOWNCTL, (void**)&app->timectl);
    rect.x = 0;
    rect.y = 10;
    rect.dx = app->width;
    rect.dy = TIMECTL_HEIGHT;
    // `̐ݒ
    ITIMECTL_SetRect(app->timectl, &rect);
    // \̐ݒ
    ITIMECTL_SetTime(app->timectl, GETTIMEMS());
    // Active  FALSE ɐݒ
    ITIMECTL_SetActive(app->timectl, FALSE);
    return;
}
